=== debian/changelog ===
centreon-broker (19.10.2-1) unstable; urgency=medium

  * Add debian/watch
  * New upstream version 19.10.2
  * Adjust debian/rules to new source layout
  * Use packaged json11

 -- Sebastien Delafond <seb@debian.org>  Fri, 27 Dec 2019 08:04:19 +0100
