=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
# see https://github.com/centreon/centreon-broker/issues/139
CXXFLAGS+=$(CPPFLAGS) -std=c++98 -fpermissive

export CMAKE_OPTIONS := \
  -DCMAKE_C_COMPILER="$(CC)" \
  -DCMAKE_CXX_COMPILER="$(CXX)" \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_PREFIX=/usr \
  -DWITH_PREFIX_BIN=/usr/sbin \
  -DWITH_PREFIX_CONF=/etc/centreon-broker \
  -DWITH_PREFIX_LIB=/usr/lib/centreon-broker \
  -DWITH_PREFIX_VAR=/var/lib/centreon-broker \
  -DWITH_LOGROTATE_SCRIPT=1 \
  -DWITH_VAR_DIR=/var/log/centreon-broker \
  -DWITH_PREFIX_MODULES=/usr/lib/centreon-broker/modules \
  -DWITH_PKGCONFIG_SCRIPT=1 \
  -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
  -DWITH_DAEMONS='central-broker;central-rrd' \
  -DWITH_STARTUP_SCRIPT=systemd \
  -DWITH_STARTUP_DIR=/lib/systemd/system \
  -DWITH_USER=centreon-broker \
  -DWITH_GROUP=centreon-broker \
  -DWITH_CONFIG_FILES=1

%:
	dh $@ --sourcedirectory=.

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=. -- $(CMAKE_OPTIONS)
