=== debian/watch ===
version=3
https://github.com/centreon/centreon-broker/tags .*/(\d[\d\.]*)\.tar\.gz debian uupdate
